package labss.lang.il.model;

import java.io.*;

/**
 * E' l'intefaccia comune a tutte le entit del linguaggio. <p/>Le classi del
 * linguaggio devono implementare una delle sotto interfacce definite.
 * 
 * @author Riccardo Solmi
 * @version 1.0
 * @see Statement
 * @see Expression
 */

public interface LanguageEntity extends Cloneable {
	/**
	 * Produce una rappresentazione testuale del programma.
	 * 
	 * @param out
	 *            Lo stream dove mandare l'output. Tipicamente
	 *            <tt>System.out</tt>.
	 */
	public void prettyPrint(PrintStream out);

	public Object clone();

	public LanguageEntity get(int index);

	public void set(int index, LanguageEntity child);

	public void add(LanguageEntity child);

	public void add(int index, LanguageEntity child);

	public LanguageEntity remove(int index);

	public int size();
}