package labss.lang.il.model.impl;

import java.io.PrintStream;

import labss.lang.il.model.Expression;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractBinaryExpression extends AbstractLanguageEntity implements Expression {
	protected Expression exp1;
	protected Expression exp2;

	public AbstractBinaryExpression(Expression exp1, Expression exp2) {
		this.exp1 = exp1;
		this.exp2 = exp2;
	}

	public Object clone() {
		AbstractBinaryExpression e = (AbstractBinaryExpression) super.clone();
		e.exp1 = (Expression) exp1.clone();
		e.exp2 = (Expression) exp2.clone();
		return e;
	}

	public Expression getExp1() {
		return exp1;
	}
	public void setExp1(Expression exp1) {
		this.exp1 = exp1;
	}
	public Expression getExp2() {
		return exp2;
	}
	public void setExp2(Expression exp2) {
		this.exp2 = exp2;
	}

	public void prettyPrint(PrintStream out) {
		exp1.prettyPrint(out);
		out.print(opStr());
		exp2.prettyPrint(out);
	}
	protected abstract String opStr();
}