package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class AssignmentStatement extends AbstractLanguageEntity implements Statement {
	private Variable id;
	private Expression exp;

  public AssignmentStatement(Expression id, Expression exp) {
    this.id = (Variable)id;
    this.exp = exp;
  }
	public Object clone() {
		AssignmentStatement s = (AssignmentStatement) super.clone();
		s.id = (Variable) id.clone();
		s.exp = (Expression) exp.clone();
		return s;
	}

	public Expression getExp() {
		return exp;
	}
	public void setExp(Expression exp) {
		this.exp = exp;
	}
	public Variable getId() {
		return id;
	}
	public void setId(Variable id) {
		this.id = id;
	}

  public void prettyPrint(PrintStream out) {
    id.prettyPrint(out);
    out.print(" = ");
    exp.prettyPrint(out);
    out.println(";");
  }

  public void execute() {
    id.setValue(exp.evaluate());
  }
}