package labss.lang.il.model.impl;

import java.io.PrintStream;
import java.util.ArrayList;

import labss.lang.il.model.LanguageEntity;
import labss.lang.il.model.Statement;

/**
 * @author Riccardo Solmi
 */

public class BlockStatement extends AbstractLanguageEntity implements Statement {
	private ArrayList<LanguageEntity> stm;

	public BlockStatement(Statement[] stm) {
		this.stm = new ArrayList<LanguageEntity>(stm.length);
		for (int i = 0; i < stm.length; i++)
			this.add(stm[i]);
	}

	@SuppressWarnings("unchecked")
	public Object clone() {
		BlockStatement s = (BlockStatement) super.clone();
		s.stm = (ArrayList<LanguageEntity>) stm.clone();
		for (int i = 0; i < s.size(); i++)
			s.set(i, (Statement) s.get(i).clone());
		return s;
	}

	public LanguageEntity get(int index) {
		return (LanguageEntity) stm.get(index);
	}

	public void set(int index, LanguageEntity child) {
		stm.set(index, child);
	}

	public void add(LanguageEntity child) {
		stm.add(child);
	}

	public void add(int index, LanguageEntity child) {
		stm.add(index, child);
	}

	public LanguageEntity remove(int index) {
		return (LanguageEntity) stm.remove(index);
	}

	public int size() {
		return stm.size();
	}

	public void prettyPrint(PrintStream out) {
		for (int i = 0; i < size(); i++)
			get(i).prettyPrint(out);
	}

	public void execute() {
		for (int i = 0; i < size(); i++)
			((Statement) get(i)).execute();
	}
}