package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class IfElseStatement extends AbstractLanguageEntity implements
		Statement {
	private Expression exp;

	private Statement thenStm;

	private Statement elseStm;

	public IfElseStatement(Expression exp, Statement thenStm, Statement elseStm) {
		this.exp = exp;
		this.thenStm = thenStm;
		this.elseStm = elseStm;
	}

	public Object clone() {
		IfElseStatement s = (IfElseStatement) super.clone();
		s.exp = (Expression) exp.clone();
		s.thenStm = (Statement) thenStm.clone();
		s.elseStm = (Statement) elseStm.clone();
		return s;
	}

	public Statement getElseStm() {
		return elseStm;
	}

	public void setElseStm(Statement elseStm) {
		this.elseStm = elseStm;
	}

	public Expression getExp() {
		return exp;
	}

	public void setExp(Expression exp) {
		this.exp = exp;
	}

	public Statement getThenStm() {
		return thenStm;
	}

	public void setThenStm(Statement thenStm) {
		this.thenStm = thenStm;
	}

	public void prettyPrint(PrintStream out) {
		out.print("if (");
		exp.prettyPrint(out);
		out.println(") {");
		thenStm.prettyPrint(out);
		out.println("} else {");
		elseStm.prettyPrint(out);
		out.println("}");
	}

	public void execute() {
		if (exp.evaluate().booleanValue())
			thenStm.execute();
		else
			elseStm.execute();
	}
}