package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */
public class IfStatement extends AbstractLanguageEntity implements Statement {
	private Expression exp;

	private Statement thenStm;

	public IfStatement(Expression exp, Statement thenStm) {
		this.exp = exp;
		this.thenStm = thenStm;
	}

	public Object clone() {
		IfStatement s = (IfStatement) super.clone();
		s.exp = (Expression) exp.clone();
		s.thenStm = (Statement) thenStm.clone();
		return s;
	}

	public Expression getExp() {
		return exp;
	}

	public void setExp(Expression exp) {
		this.exp = exp;
	}

	public Statement getThenStm() {
		return thenStm;
	}

	public void setThenStm(Statement thenStm) {
		this.thenStm = thenStm;
	}

	public void prettyPrint(PrintStream out) {
		out.print("if (");
		exp.prettyPrint(out);
		out.println(") {");
		thenStm.prettyPrint(out);
		out.println("}");
	}

	public void execute() {
		if (exp.evaluate().booleanValue())
			thenStm.execute();
	}
}