package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class Variable extends AbstractLanguageEntity implements Expression {
	private String id;

	private Literal value;

	public Variable(String id) {
		this.id = id;
	}

	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public Literal getValue() {
		return value;
	}
	public void setValue(Literal value) {
		this.value = value;
	}

	public void prettyPrint(PrintStream out) {
		out.print(id);
	}

	public Literal evaluate() {
		if (value == null)
			throw new IllegalStateException("Variabile non inizializzata");

		return value;
	}

	public String toString() {
		if (value == null)
			throw new IllegalStateException("Variabile non inizializzata");
		return value.toString();
	}
}