package labss.lang.il.model.impl;

import java.io.*;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */

public class WhileStatement extends AbstractLanguageEntity implements Statement {
	private Expression exp;
	private Statement stm;

	public WhileStatement(Expression exp, Statement stm) {
		this.exp = exp;
		this.stm = stm;
	}

	public Object clone() {
		WhileStatement s = (WhileStatement) super.clone();
		s.exp = (Expression) exp.clone();
		s.stm = (Statement) stm.clone();
		return s;
	}

	public Expression getExp() {
		return exp;
	}
	public void setExp(Expression exp) {
		this.exp = exp;
	}
	public Statement getStm() {
		return stm;
	}
	public void setStm(Statement stm) {
		this.stm = stm;
	}

	public void prettyPrint(PrintStream out) {
		out.print("while (");
		exp.prettyPrint(out);
		out.println(") {");
		stm.prettyPrint(out);
		out.println("}");
	}

	public void execute() {
		while (exp.evaluate().booleanValue())
			stm.execute();
	}
}