package labss.lang.il.model.templates;

import labss.lang.il.model.LanguageFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILLanguageFactory;
import labss.lang.il.model.impl.NullExpression;
import labss.lang.il.model.impl.NullStatement;

/**
 * @author Riccardo Solmi
 */
public class ILPrototypeManager extends PrototypeManager {
	private static ILPrototypeManager instance;
	public static ILPrototypeManager instance() {
		if (instance == null)
			instance = new ILPrototypeManager();
		return instance;
	}

	protected ILPrototypeManager() {
		final LanguageFactory lf = ILLanguageFactory.instance(); 

		put("while", lf.createWhile(NullExpression.instance, NullStatement.instance));
		put("ifThen", lf.createIf(NullExpression.instance, NullStatement.instance));
		put("ifThenElse", lf.createIf(NullExpression.instance, NullStatement.instance, NullStatement.instance));
		put("assignment", lf.createAssignment(lf.createVariable("var"), NullExpression.instance));
		put("block", lf.createBlock(new Statement[0]));
		put("intLiteral", lf.createLiteral(0));
		put("variable", lf.createVariable("var"));
		put("addition", lf.createAddition(NullExpression.instance, NullExpression.instance));
		put("subtraction", lf.createSubtraction(NullExpression.instance, NullExpression.instance));
		put("multiplication", lf.createMultiplication(NullExpression.instance, NullExpression.instance));
		put("division", lf.createDivision(NullExpression.instance, NullExpression.instance));
		put("and", lf.createAnd(NullExpression.instance, NullExpression.instance));
		put("or", lf.createOr(NullExpression.instance, NullExpression.instance));
		put("not", lf.createNot(NullExpression.instance));
		put("equals", lf.createEquals(NullExpression.instance, NullExpression.instance));
		put("or", lf.createOr(NullExpression.instance, NullExpression.instance));
		put("lessThan", lf.createLessThan(NullExpression.instance, NullExpression.instance));
		put("greaterThan", lf.createGreaterThan(NullExpression.instance, NullExpression.instance));
	}
}
