package labss.lang.il.model.templates;

import labss.lang.il.model.Expression;
import labss.lang.il.model.LanguageEntity;
import labss.lang.il.model.LanguageFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILLanguageFactory;

/**
 * @author Riccardo Solmi
 */
public class ILTemplateManager extends TemplateManager {
	private static ILTemplateManager instance;
	public static ILTemplateManager instance() {
		if (instance == null)
			instance = new ILTemplateManager();
		return instance;
	}

	protected ILTemplateManager() {
		final LanguageFactory lf = ILLanguageFactory.instance(); 
		put("while", new TemplateFactory() {
			public LanguageEntity create(Object... args) {
				return lf.createWhile((Expression) args[0], (Statement) args[1]);
			}
		});
		put("Variable", new TemplateFactory() {
			public LanguageEntity create(Object... args) {
				return lf.createVariable((String) args[0]);
			}
		});

		put("Literal", new TemplateFactory() {
			public LanguageEntity create(Object... args) {
				if (args[0] instanceof Integer)
					return lf.createLiteral((Integer) args[0]);
				else
					return lf.createLiteral((Boolean) args[0]);
			}
		});

		put("fact", new TemplateFactory() {
			public LanguageEntity create(Object... args) {
				Expression n = lf.createVariable("n");
				Expression result = (Expression) args[0];//lf.createVariable("result");
				Statement fatt = lf.createBlock(new Statement[] {
						lf.createAssignment(n, lf.createLiteral(4)),
						lf.createAssignment(result, lf.createLiteral(1)),
						lf.createWhile(lf.createGreaterThan(n, lf.createLiteral(0)), lf.createBlock(new Statement[] {
								lf.createAssignment(result, lf.createMultiplication(result, n)),
								lf.createAssignment(n,lf.createSubtraction(n, lf.createLiteral(1)))
						}))
				});
				return fatt;
			}
		});
		//...
	}
}
