package labss.lang.il.model.templates;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import labss.lang.il.model.LanguageEntity;

/**
 * @author Riccardo Solmi
 */
public class PrototypeManager {
	private Map<String, LanguageEntity> registry = new HashMap<String, LanguageEntity>();

	public LanguageEntity create(String name) {
		LanguageEntity prototype = registry.get(name);
		if (prototype == null)
			throw new IllegalArgumentException("prototype sconosciuto: "+name);

		return (LanguageEntity) prototype.clone();
	}
	public void put(String name, LanguageEntity prototype) {
		registry.put(name, prototype);
	}
	public void remove(String name) {
		registry.remove(name);
	}
	public Set names() {
		return registry.keySet();
	}
}
