package labss.lang.il.test;

import labss.lang.il.model.Expression;
import labss.lang.il.model.LanguageEntity;
import labss.lang.il.model.LanguageFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILLanguageFactory;
import labss.lang.il.model.templates.ILTemplateManager;
import labss.lang.il.model.templates.TemplateFactory;
import labss.lang.il.model.templates.TemplateManager;

public class EsempioTemplateManager {
	public static void main(String[] args) {
		TemplateManager tm = ILTemplateManager.instance();
		LanguageEntity result = tm.create("Variable", "result");
		Statement fatt = (Statement) tm.create("fact", result);
		
		fatt.prettyPrint(System.out);
		fatt.execute();
		System.out.println("n! = " + result);

		tm.create("Literal", 25).prettyPrint(System.out);
		
		tm.put("fattorialeAggiuntoDinamicamente", new TemplateFactory() {
			public LanguageEntity create(Object... args) {
				LanguageFactory lf = ILLanguageFactory.instance();
				
				Expression n = lf.createVariable("n");
				Expression result = lf.createVariable("result");
				return lf.createBlock(new Statement[] {
						lf.createAssignment(n, lf.createLiteral(4)),
						lf.createAssignment(result, lf.createLiteral(1)),
						lf.createWhile(lf.createGreaterThan(n, lf.createLiteral(0)), lf.createBlock(new Statement[] {
								lf.createAssignment(result, lf.createMultiplication(result, n)),
								lf.createAssignment(n,lf.createSubtraction(n, lf.createLiteral(1)))
						}))
				});
			}
		});
		
		Statement fatt2 = (Statement) tm.create("fattorialeAggiuntoDinamicamente");
		fatt2.prettyPrint(System.out);
		fatt2.execute();
	}
}
